package org.jboss.btison.switchyard.testbed.orderservice;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.jboss.btison.switchyard.testbed.ws.model.OrderAck;
import org.w3c.dom.Document;

public class CamelServiceRoute extends RouteBuilder {

    @Override
    public void configure() throws Exception {
        
        
        onException(Exception.class)
        .process(
                new Processor() {
                    public void process(Exchange exchange) throws Exception {

                        Exception exception = (Exception) exchange.getProperty(Exchange.EXCEPTION_CAUGHT);
                        OrderAck orderAck = new OrderAck();
                        orderAck.setAccepted(false);
                        orderAck.setStatus(exception.getMessage());
                        
                        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
                        Document doc = dbf.newDocumentBuilder().newDocument();
                        
                        JAXBContext context = JAXBContext.newInstance(OrderAck.class);
                        Marshaller marshaller = context.createMarshaller();
                        marshaller.marshal(orderAck, doc);                        
                        
                        exchange.getIn().setBody( doc.getDocumentElement() );
                        //exchange.getOut().setBody( exchange.getIn() );
                    }
                })
        .to("direct://reply")
        .handled(true);
        
        from("switchyard://OrderService")
          .handleFault()
          .log("Received message for 'OrderService' : ${body}")
          .to("switchyard://OrderServiceReference")
          .to("direct:reply");
        
        from("direct://reply")
          .log("Received response from 'OrderService' : ${body}");
    }

}
